#define GL_GLEXT_PROTOTYPES 1
#include <GL/gl.h>
#include <GLFW/glfw3.h>
#include <libmbtk/backend.h>
#include <libmbtk/util.h>
#include "vtvx.h"
#include "vtpr.h"
#include <genvector/vtl0.h>
#include "../common/threads.h"
#include <ft2build.h>
#include FT_FREETYPE_H


typedef struct glfw_font_s {
	FT_Face face;
	int size; /* user requested size */
	int asc, dsc;
} glfw_font_t;

typedef struct mbtk_glfw_event_s mbtk_glfw_event_t;
struct mbtk_glfw_event_s {
	mbtk_event_t ev;
	double timestamp;
	mbtk_glfw_event_t *next; /* singly linked list in the per display event queue */
};

typedef struct glfw_win_s glfw_win_t;

typedef struct glfw_display_s {
	FT_Library lib;
	uall_slabs_t evs;        /* event allocation */
	mbtk_glfw_event_t *evq;  /* event queue, head (NULL if empty) */
	mbtk_glfw_event_t *evq_tail;  /* event queue, tail (last event appended) */
	double base_time;

	struct {
		/* output */
		char *data;
		size_t len;
		unsigned loaded:1;

		/* thread */
		unsigned disabled:1;
		unsigned thread_inited:1;
		mbtk_be_thread_t tid;
		mbtk_be_sem_t handled;       /* main to thread: 0: thread's waiting non-blocking after a read; when main finishes picking up it increases it back to 1 to start the next read */
		mbtk_be_sem_t enable;        /* main to thread: after a succesful read, wait until enable is 1 to report it */
	} iot_stdio;
	struct {
		/* output */
		int fd;
		unsigned readable:1;
		unsigned writable:1;
		unsigned closed:1;
		unsigned loaded:1;

		/* thread */
		unsigned thread_inited:1;
		mbtk_be_thread_t tid;
		mbtk_be_sem_t handled;       /* main to thread: 0: thread's waiting non-blocking after a read; when main finishes picking up it increases it back to 1 to start the next read */
		int ctrlw, ctrlr;       /* control pipe fds; w is write from main, r is read on the thread's side */
	} iot_fdwatch;

} glfw_display_t;

struct glfw_win_s {
	GLFWwindow *window;
	GLfloat red, green, blue, alpha;
	glfw_font_t *font;
	GLuint program, inputColor_location, inputTexture_location, xform_location, position_buffer;
	float vertbuf_last_r, vertbuf_last_g, vertbuf_last_b, vertbuf_last_a;
	vtvx_t vxbuf;
	vtpr_t prbuf;
	long last_mouse_x, last_mouse_y;
};

