#include <stdlib.h>
#include <string.h>
#include "style.h"
#include "libmbtk.h"
#include "display.h"

static gdl_list_t mbtk_active_be;

static int init_once = 0;
int mbtk_be_init(mbtk_backend_t *be)
{
	int res;

	if (!init_once) {
		mbtk_style_init();
		init_once = 1;
	}

	memset(&be->displays, 0, sizeof(be->displays));

	if (be->be_init != NULL)
		res = be->be_init(be);
	else
		res = 0;

	if (res == 0)
		gdl_append(&mbtk_active_be, be, link);

	return res;
}

void mbtk_be_uninit(mbtk_backend_t *be)
{
	mbtk_display_t *d;

	for(d = gdl_first(&be->displays); d != NULL; d = gdl_first(&be->displays))
		mbtk_display_uninit(be, d);

	gdl_remove(&mbtk_active_be, be, link);
	if (be->be_uninit != NULL)
		be->be_uninit(be);
}


void mbtk_uninit()
{
	mbtk_backend_t *be;

	for(be = gdl_first(&mbtk_active_be); be != NULL; be = gdl_first(&mbtk_active_be))
		mbtk_be_uninit(be);

	mbtk_kw_uninit();
}

