#ifndef LIBMBTK_WIDGET_FLAGS_H
#define LIBMBTK_WIDGET_FLAGS_H

typedef struct mbtk_widget_flags_s {
	/* widget states supported by all widgets: user accessible */
	unsigned int disabled:1;        /* won't react to user input or focus */
	unsigned int activated:1;       /* e.g. push button pushed, checkbox ticked */
	unsigned int focus:1;
	unsigned int hide:1;

	/* widget states supported by all widgets: internal */
	unsigned int dirty:1;           /* set to 1 if redraw is required */
	unsigned int caller_alloced:1;  /* 1 if caller supplied the storage and mbtk_widget_destroy() won't free it */
	unsigned int created:1;         /* 1 if the widget is created, 0 if it is already destroyed */

	unsigned int focus_pref:8;      /* preference on the focus - when a new layout is created and the default focus needs to be determined; higher value is more preferred; 0 means the widget doesn't want to get focused */

} mbtk_widget_flags_t;

#endif
